megatools-ls(1)

NAME
megatools ls - List files stored in the cloud

SYNOPSIS
    megatools ls [-e] [-h] [--header] [-l] [-R] [-n] [<remotepaths>...]

DESCRIPTION
Lists files stored on Mega.nz, exports public download links.

OPTIONS

--export , -e
    For all files that are going to be listed, also display public download link with file key. NOTE: Folders export doesn’t work yet.

--human , -h
    Display file sizes in a human readable format.

--header
    For long list format, display header describing all listed columns.

--long , -l
    List additional information about listed filesystem nodes. Node handle, owner, node type, file size, and the last modification date.

--recursive , -R
    List directories recursively. This is the default if no paths are specified.

--names , -n
    Show only names of nodes within the directory. This option has effect only if you specified a single path on a command line.

--print0 , -0
    Separate file names with NULs instead of new lines.

-u <email> , --username <email>
    Account username (email)

-p <password> , --password <password>
    Account password

--no-ask-password
    Never ask interactively for a password

--reload
    Reload filesystem cache

--limit-speed <speed>
    Set maximum allowed upload and download speed in KiB/s. This option overrides config file settings. 0 means no limit. When using ParallelTransfers > 1, upload speed limit is applied to each transfer individually.

--proxy <proxy>
    Use proxy server to connect to mega.nz. This option overrides config file settings. More information can be found in libcurl documentation at ⟨https://curl.haxx.se/libcurl/c/CURLOPT_PROXY.html⟩. Some acceptable values are:

    •   \FCnone\F[] : Disable proxy if it was enabled in the config file.

    •   \FCsocks5://localhost:9050\F[] : Local SOCKSv5 proxy server

    •   \FCsocks5h://localhost:9050\F[] : Local SOCKSv5 proxy server with DNS handled by the proxy

--netif <ifname|ip>
    Network interface or local IP address used for outgoing connections. You have to specify IP address bound to some of your local network interfaces, when specifying an IP address.

--ip-proto <proto>
    Which IP protocol to prefer when connecting to mega.nz (v4, v6, or any). This is just an advisory option. Megatools will resolve mega.nz domain, and then use an A or AAAA record based on the stated preference.

--config <path>
    Load configuration from a file

--ignore-config-file
    Disable loading .megarc

--debug [<options>]
    Enable debugging of various aspects of the megatools operation. You may enable multiple debugging options separated by commas. (eg. \FC--debug api,fs\F[]) Available options are:

    •   \FChttp\F[]: Dump HTTP request/response details (can be used to debug connection/proxy issues)

    •   \FCapi\F[]: Dump Mega.nz API calls

    •   \FCfs\F[]: Dump Mega.nz filesystem (may require \FC--reload\F[] to actually print something)

    •   \FCcache\F[]: Dump cache contents

    •   \FCtman\F[]: Dump transfer manager events

--version
    Show version information

<remotepaths>
    One or more remote filesystem paths to list. If path points to a directory, contents of the directory and the directory itself is listed. When \FC--names\F[] is given, only the contents of the directory is listed.
    If path points to a file, the file itself is listed.
    If omitted, the entire remote filesystem is listed recursively.

EXAMPLES

•   List all files:
    \FC$ megatools ls
    /Contacts
    /Inbox
    /Root
    /Root/README
    /Root/bigfile
    /Trash\F[]

•   List all files in the /Root, recursively and with details:
    \FC$ megatools ls -l /Root
    3RsS2QwJ                2             - 2013-01-22 12:31:06 /Root
    2FFSiaKZ    Xz2tWWB5Dmo 0          2686 2013-04-15 08:33:47 /Root/README
    udtDgR7I    Xz2tWWB5Dmo 0    4405067776 2013-04-10 19:16:02 /Root/bigfile\F[]

•   List all files in the /Root, recursively and with details, show only file names:
    \FC$ megatools ls -ln /Root
    2FFSiaKZ    Xz2tWWB5Dmo 0          2686 2013-04-15 08:33:47 README
    udtDgR7I    Xz2tWWB5Dmo 0    4405067776 2013-04-10 19:16:02 bigfile\F[]

•   Export download links:
    \FC$ megatools ls -e /Root/README
    https://mega.nz/#!OFFRlbgR!k5rWmLp3mxB0gsq07Ii67PLd9L0wq4KondFLDlfH3Uw /Root/README\F[]

•   List files in a more human readable format:
    \FC$ megatools ls -hnl --header /Root/README
    ===================================================================================
    Handle      Owner       T          Size Mod. Date           Filename
    ===================================================================================
    2FFSiaKZ    Xz2tWWB5Dmo 0       2.6 KiB 2013-04-15 08:33:47 README\F[]

REMOTE FILESYSTEM
Mega.nz filesystem is represented as a tree of nodes of various types. Nodes are identified by a 8 character node handles (eg. \FC7Fdi3ZjC\F[]). Structure of the filesystem is not encrypted.

Megatools maps node tree structure to a traditional filesystem paths (eg. \FC/Root/SomeFile.DAT\F[]).

NOTE: By the nature of Mega.nz storage, several files in the directory can have the same name. To allow access to such files, the names of conflicting files are extended by appending dot and their node handle like this:

\FC/Root/conflictingfile
/Root/conflictingfile.7Fdi3ZjC
/Root/conflictingfile.mEU23aSD\F[]

You need to be aware of several special folders:

/Root
    Writable directory representing the root of the filesystem.

/Trash
    Trash directory where Mega.nz web client moves deleted files. This directory is not used by megatools when removing files.

/Inbox
    Not sure.

/Contacts
    Directory containing subdirectories representing your contacts list. If you want to add contacts to the list, simply create subdirectory named after the contact you want to add.

/Contacts/<email>
    Directories representing individual contacts in your contacts list. These directories contain folders that others shared with you. All shared files are read-only, at the moment.

SEE ALSO
megatools(1), megarc(5), megatools-df(1), megatools-dl(1), megatools-get(1), megatools-ls(1), megatools-mkdir(1), megatools-put(1), megatools-reg(1), megatools-rm(1), megatools-copy(1).

MEGATOOLS
Part of the megatools(1) suite of commands.

BUGS
Report bugs to . Your message will end up in a public archive, so be careful what you say or send.

AUTHOR
Megatools was written by Ondrej Jirman < >, 2013-2022.

Official website is ⟨http://megatools.megous.com⟩.